/*
 *  Calculate the radius on a peroidic lattice
 *
 */

#include <stdio.h>
#include <math.h>
#include<string.h>



float peroidic_radius(int x, int y, int z, int nx)
{
  float rad ;

  if( x >= nx/2 )  x -= nx ;
  if( y >= nx/2 )  y -= nx ;
  if( z >= nx/2 )  z -= nx ;

  rad = (float) sqrt( (double)  x*x +  y*y +  z*z ) ;

  return rad ;

}



/**
 **  Allow for a squeeze in the x direction
 **
 **
 **/

float peroidic_radius_x_squeeze(int x, int y, int z, int nx, float squeeze)
{
  float rad ;

  if( x >= nx/2 )  x -= nx ;
  if( y >= nx/2 )  y -= nx ;
  if( z >= nx/2 )  z -= nx ;

  rad = (float) sqrt( (double)  x*x*squeeze*squeeze  +  
		     y*y +  z*z ) ;

  return rad ;
}
