// Automatically generated by Paradyn/igen v3.1#0
#ifndef dataManager_thread_BASE_H
#define dataManager_thread_BASE_H
#include "pdutil/h/rpcUtil.h"
#include "thread/h/thread.h"

#ifdef IGEN_ERR_ASSERT_ON
#ifndef IGEN_ERR_ASSERT
#define IGEN_ERR_ASSERT assert(0)
#endif
#else
#define IGEN_ERR_ASSERT
#endif


 // Errors that can occur internal to igen
#ifndef _IGEN_ERR_DEF
#define _IGEN_ERR_DEF
typedef enum e_IGEN_ERR {
                       igen_no_err=0,
                       igen_encode_err,
                       igen_decode_err,
                       igen_send_err,
                       igen_read_err,
                       igen_request_err,
                       igen_call_err,
                       igen_proto_err
                       }  IGEN_ERR;

#endif
/*

 * dataManager.h - exported services of the Data Mgr thread of paradyn.

 * $Id: dataManager.I,v 1.99 2000/10/17 17:27:45 schendel Exp $

 */



#ifndef MMTHREAD_H

#define MMTHREAD_H



#include "common/h/list.h"

#include "pdutilOld/h/sys.h"

#include "dyninstRPC.xdr.h"

#include "visi.xdr.h"

#include "pdutilOld/h/aggregation.h"

#include "pdutilOld/h/stringPool.h"

#include "paradyn/src/DMthread/DMinclude.h"

#include "paradyn/src/DMthread/DVbufferpool.h"



typedef enum {Global, Phase, All} SaveRequestType;



typedef enum { Trace, Sample } dataType;



/*

 * error handler call back.

 *

 */

typedef void (*errorHandler)(int errno, char *message);



/*

 * Handler that gets called when new sample data is delivered.

 *

 *   handle - a performance stream handle from createPerformanceStream

 *   mi - a metricInstance returned by enableDataCollection

 *   buckets - array of sampleValue filled by the DM 

 *   first - the first bucket value

 *   count - number of bucket values in buckets

 *    

 */

typedef void (*sampleDataCallbackFunc)(vector<dataValueType> *data,

				       u_int num_data_values);



/*

 * Handler that gets called when new trace data is available.

 *   

 *   handle - a performance stream handle from createPerformanceStream

 *   mi - a metricInstance returned by enableDataCollection

 *   time - time of the event.

 *   eventSize - size of the event specific data.

 *   eventData - event specific data.

 */

typedef void (*traceDataCallbackFunc)(perfStreamHandle handle, 

				      metricInstanceHandle mi, 

				      timeStamp time, 

				      int eventSize, 

				      void *eventData);



/*

 * union to hold two types of data callback.

 *

 */

union dataCallback {

    sampleDataCallbackFunc 	sample;

    traceDataCallbackFunc	trace;

};



typedef union dataCallback dataCallback;



/*

 * Handler that gets called when a new metric is defined.

 *

 * handle - a performance stream handle from createPerformanceStream

 * metricInfo - info about metric, client is resp. for deleting this struct

 *

 */

typedef void (*metricInfoCallback)(perfStreamHandle, 

				   const char *name,

				   int style,

				   int aggregate,

				   const char *units,

				   metricHandle handle,

				   dm_MetUnitsType units_type);



/*

 * Handler that gets called when a new resource is defined.

 *

 * handle - a performance stream handle from createPerformanceStream

 * parent		- parent of new resource

 * newResource		- new resource being created

 * name			- name of the new resource, client must delete

 *

 */

typedef void (*resourceInfoCallback)(perfStreamHandle handle, 

				     resourceHandle parent, 

				     resourceHandle newResource, 

				     const char *name,

				     const char *abstraction);



typedef enum { batchStart, batchEnd } batchMode;



typedef void (*resourceBatchModeCallback)(perfStreamHandle, batchMode mode); 



typedef void (*histFoldCallback)(perfStreamHandle, timeStamp width, phaseType);



typedef enum { appRunning, appPaused, appExited } appState;



typedef void (*appStateChangeCallback)(perfStreamHandle, appState state);



typedef void (*newPhaseCallback)(perfStreamHandle handle, 

				 const char *name, 

				 phaseHandle phase,

				 timeStamp begin, 

				 timeStamp end, 

				 float bucketwidth,

				 bool with_new_pc,

				 bool with_visis); 



typedef void (*forceFlushCallbackFunc)();



/*

 * Handler that gets called when there is a response to a 

 * getPredictedDataCost call 

 *   

 *   m_handle - the metricHandle assoc. with the request

 *   rl_handle - the resourceListHandle assoc. with the request 

 *   cost     - the cost of enabling the metric/focus pair

 *   clientId - the identifier passed by the calling thread

 */

typedef void (*predDataCostCallbackFunc)(u_int clientId,

					 float cost);



/*

 * Handler that gets called when there is a response to an enableData request 

 *   

 * response -   vector of responses to enable request one element for each   

 *		element in the vector passed by client to enableData request

 * request_id - identifier that client thread associated with this call

 *              (passed to DM on enableDataRequest)

 */

typedef void (*enableDataCallbackFunc)(vector<metricInstInfo> *response,

				       u_int request_id);



struct controlCallback {

    metricInfoCallback		mFunc;

    resourceInfoCallback	rFunc;

    resourceBatchModeCallback	bFunc;

    histFoldCallback		fFunc;

    appStateChangeCallback	sFunc;

    newPhaseCallback	        pFunc;

    predDataCostCallbackFunc    cFunc;

    enableDataCallbackFunc	eFunc;

    forceFlushCallbackFunc      flFunc;

};



typedef struct controlCallback controlCallback;







#endif

class T_dataManager  {
public:
typedef enum {
 } class_ids;
struct T_addDaemon{ 
const char* machine;
const char* login;
const char* name;
};
typedef struct T_addDaemon T_addDaemon;
struct T_defineDaemon{ 
const char* command;
const char* dir;
const char* login;
const char* name;
const char* machine;
const char* remote_shell;
const char* flavor;
};
typedef struct T_defineDaemon T_defineDaemon;
struct T_addExecutable{ 
const char* machine;
const char* login;
const char* name;
const char* dir;
const vector<string>* argv;
};
typedef struct T_addExecutable T_addExecutable;
struct T_attach{ 
const char* machine;
const char* user;
const char* cmd;
const char* pidStr;
const char* daemonName;
int afterAttach;
};
typedef struct T_attach T_attach;
struct T_saveAllData{ 
const char* dirname;
SaveRequestType optionFlag;
};
typedef struct T_saveAllData T_saveAllData;
struct T_createPerformanceStream{ 
dataType var_14;
dataCallback var_15;
controlCallback var_16;
};
typedef struct T_createPerformanceStream T_createPerformanceStream;
struct T_enableDataRequest{ 
perfStreamHandle ps_handle;
perfStreamHandle pt_handle;
vector<metric_focus_pair>* request;
u_int request_Id;
phaseType type;
u_int phaseId;
u_int persistent_data;
u_int persistent_collection;
u_int phase_persistent_data;
};
typedef struct T_enableDataRequest T_enableDataRequest;
struct T_enableDataRequest2{ 
perfStreamHandle ps_handle;
vector<metricRLType>* request;
u_int request_Id;
phaseType type;
u_int phaseId;
u_int persistent_data;
u_int persistent_collection;
u_int phase_persistent_data;
};
typedef struct T_enableDataRequest2 T_enableDataRequest2;
struct T_disableDataCollection{ 
perfStreamHandle ps_handle;
perfStreamHandle pt_handle;
metricInstanceHandle var_22;
phaseType var_23;
};
typedef struct T_disableDataCollection T_disableDataCollection;
struct T_disableDataAndClearPersistentData{ 
perfStreamHandle ps_handle;
perfStreamHandle pt_handle;
metricInstanceHandle mi_handle;
phaseType p_type;
bool clear_persistent_data;
bool clear_phase_persistent_data;
};
typedef struct T_disableDataAndClearPersistentData T_disableDataAndClearPersistentData;
struct T_magnify{ 
resourceHandle rh;
resourceListHandle rlh;
magnifyType m;
resourceHandle currentSearchPath;
};
typedef struct T_magnify T_magnify;
struct T_constrain{ 
resourceHandle rh;
resourceListHandle rlh;
};
typedef struct T_constrain T_constrain;
struct T_getPredictedDataCost{ 
perfStreamHandle var_42;
metricHandle var_43;
resourceListHandle var_44;
u_int var_45;
};
typedef struct T_getPredictedDataCost T_getPredictedDataCost;
struct T_newResource{ 
resourceHandle parent;
const char* name;
u_int type;
};
typedef struct T_newResource T_newResource;
struct T_setResourceSearchSuppress{ 
resourceHandle res_handle;
bool newValue;
};
typedef struct T_setResourceSearchSuppress T_setResourceSearchSuppress;
struct T_getSampleValues{ 
metricInstanceHandle mi;
sampleValue* buckets;
int numberOfBuckets;
int first;
phaseType phase;
};
typedef struct T_getSampleValues T_getSampleValues;
struct T_getArchiveValues{ 
metricInstanceHandle mi;
sampleValue* buckets;
int numberOfBuckets;
int first;
phaseHandle phase_id;
};
typedef struct T_getArchiveValues T_getArchiveValues;
struct T_StartPhase{ 
timeStamp start_Time;
const char* name;
bool with_new_pc;
bool with_visis;
};
typedef struct T_StartPhase T_StartPhase;
struct T_newMetricDefined{ 
metricInfoCallback var_98;
perfStreamHandle var_99;
const char* name;
int style;
int aggregate;
const char* units;
metricHandle handle;
dm_MetUnitsType units_type;
};
typedef struct T_newMetricDefined T_newMetricDefined;
struct T_newResourceDefined{ 
resourceInfoCallback var_101;
perfStreamHandle var_102;
resourceHandle parent;
resourceHandle newResource;
const char* name;
const char* abstr;
};
typedef struct T_newResourceDefined T_newResourceDefined;
struct T_changeResourceBatchMode{ 
resourceBatchModeCallback var_104;
perfStreamHandle var_105;
batchMode mode;
};
typedef struct T_changeResourceBatchMode T_changeResourceBatchMode;
struct T_newPerfData{ 
sampleDataCallbackFunc sampleFunc;
vector<dataValueType>* data;
u_int num_data_values;
};
typedef struct T_newPerfData T_newPerfData;
struct T_newTracePerfData{ 
traceDataCallbackFunc traceFunc;
vector<traceDataValueType>* traceData;
u_int num_traceData_values;
};
typedef struct T_newTracePerfData T_newTracePerfData;
struct T_predictedDataCost{ 
predDataCostCallbackFunc func;
metricHandle m_handle;
resourceListHandle rl_handle;
float cost;
u_int clientId;
};
typedef struct T_predictedDataCost T_predictedDataCost;
struct T_enableDataCallback{ 
enableDataCallbackFunc func;
vector<metricInstInfo>* response;
u_int request_id;
};
typedef struct T_enableDataCallback T_enableDataCallback;
struct T_histFold{ 
histFoldCallback var_112;
perfStreamHandle var_113;
timeStamp width;
phaseType var_114;
};
typedef struct T_histFold T_histFold;
struct T_changeState{ 
appStateChangeCallback var_116;
perfStreamHandle var_117;
appState var_118;
};
typedef struct T_changeState T_changeState;
struct T_newPhaseInfo{ 
newPhaseCallback var_120;
perfStreamHandle var_121;
const char* var_122;
phaseHandle var_123;
timeStamp var_124;
timeStamp var_125;
float var_126;
bool var_127;
bool var_128;
};
typedef struct T_newPhaseInfo T_newPhaseInfo;
union msg_buf { 
T_addDaemon addDaemon_call;
bool addDaemon_req;
T_defineDaemon defineDaemon_call;
bool defineDaemon_req;
T_addExecutable addExecutable_call;
bool addExecutable_req;
T_attach attach_call;
bool attach_req;
bool applicationDefined_req;
bool startApplication_req;
bool pauseApplication_req;
int pauseProcess_call;
bool pauseProcess_req;
bool continueApplication_req;
int continueProcess_call;
bool continueProcess_req;
bool detachApplication_call;
bool detachApplication_req;
T_saveAllData saveAllData_call;
const char* saveAllResources_call;
T_createPerformanceStream createPerformanceStream_call;
perfStreamHandle createPerformanceStream_req;
perfStreamHandle destroyPerformanceStream_call;
int destroyPerformanceStream_req;
T_enableDataRequest enableDataRequest_call;
T_enableDataRequest2 enableDataRequest2_call;
T_disableDataCollection disableDataCollection_call;
T_disableDataAndClearPersistentData disableDataAndClearPersistentData_call;
T_magnify magnify_call;
vector<rlNameId>* magnify_req;
T_constrain constrain_call;
resourceListHandle* constrain_req;
T_constrain morespecific_call;
resourceListHandle* morespecific_req;
resourceListHandle isSuppressed_call;
bool isSuppressed_req;
metricInstanceHandle getFocusNameFromMI_call;
const char* getFocusNameFromMI_req;
const vector<resourceHandle>* getFocusName_call;
const char* getFocusName_req;
resourceListHandle getFocusNameFromHandle_call;
const char* getFocusNameFromHandle_req;
metricInstanceHandle setPersistentCollection_call;
metricInstanceHandle clearPersistentCollection_call;
metricInstanceHandle setPersistentData_call;
metricInstanceHandle clearPersistentData_call;
T_getPredictedDataCost getPredictedDataCost_call;
timeStamp getCurrentBucketWidth_req;
timeStamp getGlobalBucketWidth_req;
u_int getCurrentPhaseId_req;
timeStamp getCurrentStartTime_req;
int getMaxBins_req;
resourceHandle* getRootResource_req;
vector<resourceHandle>* getRootResources_req;
T_newResource newResource_call;
resourceHandle newResource_req;
const vector<resourceHandle>* getResourceList_call;
resourceListHandle getResourceList_req;
resourceListHandle getResourceHandles_call;
vector<resourceHandle>* getResourceHandles_req;
const char* findResource_call;
resourceHandle* findResource_req;
resourceHandle getResourceLabelName_call;
const char* getResourceLabelName_req;
resourceHandle getResourceName_call;
const char* getResourceName_req;
const char* findResourceList_call;
resourceListHandle* findResourceList_req;
T_setResourceSearchSuppress setResourceSearchSuppress_call;
T_setResourceSearchSuppress setResourceSearchChildrenSuppress_call;
T_setResourceSearchSuppress setResourceInstSuppress_call;
bool getAvailableMetrics_call;
vector<string>* getAvailableMetrics_req;
bool getAvailableMetInfo_call;
vector<met_name_id>* getAvailableMetInfo_req;
const char* findMetric_call;
metricHandle* findMetric_req;
metricHandle getMetricName_call;
const char* getMetricName_req;
metricHandle getMetricInfo_call;
T_dyninstRPC::metricInfo* getMetricInfo_req;
metricInstanceHandle getMetric_call;
metricHandle* getMetric_req;
metricInstanceHandle getMetricNameFromMI_call;
const char* getMetricNameFromMI_req;
metricInstanceHandle getMetricValue_call;
sampleValue getMetricValue_req;
T_getSampleValues getSampleValues_call;
int getSampleValues_req;
T_getArchiveValues getArchiveValues_call;
int getArchiveValues_req;
metricInstanceHandle getTotValue_call;
sampleValue getTotValue_req;
T_StartPhase StartPhase_call;
vector<T_visi::phase_info>* getAllPhaseInfo_req;
int coreProcess_call;
const char* printDaemonStartInfo_call;
vector<string>* getAvailableDaemons_req;
T_newMetricDefined newMetricDefined_call;
T_newResourceDefined newResourceDefined_call;
T_changeResourceBatchMode changeResourceBatchMode_call;
T_newPerfData newPerfData_call;
T_newTracePerfData newTracePerfData_call;
T_predictedDataCost predictedDataCost_call;
T_enableDataCallback enableDataCallback_call;
forceFlushCallbackFunc forceFlush_call;
T_histFold histFold_call;
T_changeState changeState_call;
T_newPhaseInfo newPhaseInfo_call;
};
enum message_tags {
verify = 2500,
addDaemon_REQ, addDaemon_RESP,
defineDaemon_REQ, defineDaemon_RESP,
addExecutable_REQ, addExecutable_RESP,
attach_REQ, attach_RESP,
applicationDefined_REQ, applicationDefined_RESP,
startApplication_REQ, startApplication_RESP,
pauseApplication_REQ, pauseApplication_RESP,
createCallGraph_REQ, createCallGraph_RESP,
pauseProcess_REQ, pauseProcess_RESP,
continueApplication_REQ, continueApplication_RESP,
continueProcess_REQ, continueProcess_RESP,
detachApplication_REQ, detachApplication_RESP,
saveAllData_REQ, saveAllData_RESP,
saveAllResources_REQ, saveAllResources_RESP,
createPerformanceStream_REQ, createPerformanceStream_RESP,
destroyPerformanceStream_REQ, destroyPerformanceStream_RESP,
enableDataRequest_REQ, enableDataRequest_RESP,
enableDataRequest2_REQ, enableDataRequest2_RESP,
disableDataCollection_REQ, disableDataCollection_RESP,
disableDataAndClearPersistentData_REQ, disableDataAndClearPersistentData_RESP,
magnify_REQ, magnify_RESP,
constrain_REQ, constrain_RESP,
morespecific_REQ, morespecific_RESP,
isSuppressed_REQ, isSuppressed_RESP,
getFocusNameFromMI_REQ, getFocusNameFromMI_RESP,
getFocusName_REQ, getFocusName_RESP,
getFocusNameFromHandle_REQ, getFocusNameFromHandle_RESP,
setPersistentCollection_REQ, setPersistentCollection_RESP,
clearPersistentCollection_REQ, clearPersistentCollection_RESP,
setPersistentData_REQ, setPersistentData_RESP,
clearPersistentData_REQ, clearPersistentData_RESP,
getPredictedDataCost_REQ, getPredictedDataCost_RESP,
getCurrentBucketWidth_REQ, getCurrentBucketWidth_RESP,
getGlobalBucketWidth_REQ, getGlobalBucketWidth_RESP,
getCurrentPhaseId_REQ, getCurrentPhaseId_RESP,
getCurrentStartTime_REQ, getCurrentStartTime_RESP,
getMaxBins_REQ, getMaxBins_RESP,
getRootResource_REQ, getRootResource_RESP,
getRootResources_REQ, getRootResources_RESP,
newResource_REQ, newResource_RESP,
getResourceList_REQ, getResourceList_RESP,
getResourceHandles_REQ, getResourceHandles_RESP,
findResource_REQ, findResource_RESP,
getResourceLabelName_REQ, getResourceLabelName_RESP,
getResourceName_REQ, getResourceName_RESP,
findResourceList_REQ, findResourceList_RESP,
setResourceSearchSuppress_REQ, setResourceSearchSuppress_RESP,
setResourceSearchChildrenSuppress_REQ, setResourceSearchChildrenSuppress_RESP,
setResourceInstSuppress_REQ, setResourceInstSuppress_RESP,
getAvailableMetrics_REQ, getAvailableMetrics_RESP,
getAvailableMetInfo_REQ, getAvailableMetInfo_RESP,
findMetric_REQ, findMetric_RESP,
getMetricName_REQ, getMetricName_RESP,
getMetricInfo_REQ, getMetricInfo_RESP,
getMetric_REQ, getMetric_RESP,
getMetricNameFromMI_REQ, getMetricNameFromMI_RESP,
getMetricValue_REQ, getMetricValue_RESP,
getSampleValues_REQ, getSampleValues_RESP,
getArchiveValues_REQ, getArchiveValues_RESP,
getTotValue_REQ, getTotValue_RESP,
StartPhase_REQ, StartPhase_RESP,
getAllPhaseInfo_REQ, getAllPhaseInfo_RESP,
printResources_REQ, printResources_RESP,
printStatus_REQ, printStatus_RESP,
coreProcess_REQ, coreProcess_RESP,
printDaemons_REQ, printDaemons_RESP,
displayDaemonStartInfo_REQ, displayDaemonStartInfo_RESP,
printDaemonStartInfo_REQ, printDaemonStartInfo_RESP,
displayParadynGeneralInfo_REQ, displayParadynGeneralInfo_RESP,
displayParadynLicenseInfo_REQ, displayParadynLicenseInfo_RESP,
displayParadynReleaseInfo_REQ, displayParadynReleaseInfo_RESP,
displayParadynVersionInfo_REQ, displayParadynVersionInfo_RESP,
getAvailableDaemons_REQ, getAvailableDaemons_RESP,
newMetricDefined_REQ, newMetricDefined_RESP,
newResourceDefined_REQ, newResourceDefined_RESP,
changeResourceBatchMode_REQ, changeResourceBatchMode_RESP,
newPerfData_REQ, newPerfData_RESP,
newTracePerfData_REQ, newTracePerfData_RESP,
predictedDataCost_REQ, predictedDataCost_RESP,
enableDataCallback_REQ, enableDataCallback_RESP,
forceFlush_REQ, forceFlush_RESP,
histFold_REQ, histFold_RESP,
changeState_REQ, changeState_RESP,
newPhaseInfo_REQ, newPhaseInfo_RESP,
error, last }; 
 typedef enum message_tags message_tags;
};

#endif

