// Automatically generated by Paradyn/igen v3.1#0
#ifndef dyninstRPC_xdr_BASE_H
#define dyninstRPC_xdr_BASE_H
#include "pdutil/h/rpcUtil.h"
 
#ifdef IGEN_ERR_ASSERT_ON
#ifndef IGEN_ERR_ASSERT
#define IGEN_ERR_ASSERT assert(0)
#endif
#else
#define IGEN_ERR_ASSERT
#endif


 // Errors that can occur internal to igen
#ifndef _IGEN_ERR_DEF
#define _IGEN_ERR_DEF
typedef enum e_IGEN_ERR {
                       igen_no_err=0,
                       igen_encode_err,
                       igen_decode_err,
                       igen_send_err,
                       igen_read_err,
                       igen_request_err,
                       igen_call_err,
                       igen_proto_err
                       }  IGEN_ERR;

#endif
/*

 * Copyright (c) 1996 Barton P. Miller

 * 

 * We provide the Paradyn Parallel Performance Tools (below

 * described as Paradyn") on an AS IS basis, and do not warrant its

 * validity or performance.  We reserve the right to update, modify,

 * or discontinue this software at any time.  We shall have no

 * obligation to supply such updates or modifications or any other

 * form of support to you.

 * 

 * This license is for research uses.  For such uses, there is no

 * charge. We define "research use" to mean you may freely use it

 * inside your organization for whatever purposes you see fit. But you

 * may not re-distribute Paradyn or parts of Paradyn, in any form

 * source or binary (including derivatives), electronic or otherwise,

 * to any other organization or entity without our permission.

 * 

 * (for other uses, please contact us at paradyn@cs.wisc.edu)

 * 

 * All warranties, including without limitation, any warranty of

 * merchantability or fitness for a particular purpose, are hereby

 * excluded.

 * 

 * By your use of Paradyn, you understand and agree that we (or any

 * other person or entity with proprietary rights in Paradyn) are

 * under no obligation to provide either maintenance services,

 * update services, notices of latent defects, or correction of

 * defects for Paradyn.

 * 

 * Even if advised of the possibility of such damages, under no

 * circumstances shall we (or any other person or entity with

 * proprietary rights in the software licensed hereunder) be liable

 * to you or any third party for direct, indirect, or consequential

 * damages of any character regardless of type of action, including,

 * without limitation, loss of profits, loss of use, loss of good

 * will, or computer failure or malfunction.  You agree to indemnify

 * us (and any other person or entity with proprietary rights in the

 * software licensed hereunder) for any and all liability it may

 * incur to third parties resulting from your use of Paradyn.

 */



/* $Id: dyninstRPC.I,v 1.86 2000/10/17 17:27:46 schendel Exp $

 */



#define MetStyleEventCounter	0

#define MetStyleSampledFunction	1



#include "common/h/Types.h"

#include "pdutilOld/h/aggregation.h"

#include "paradyn/src/met/mdl.h"







// trace data streams





/* used by paradynd to inform a change in the status of an application. */

// typedef enum { procPaused, procExited } processStatus_t;

#define procPaused 0

#define procExited 1

typedef u_int processStatus_t;















































/* descriptive information about a metric */













/*

 * Create a paradynd process.

 *

 */

int createDaemon(string machine,

		 string login,

		 string name,

		 vector<string> argv);







class T_dyninstRPC  {
public:
typedef enum {
 mdl_expr_id = 6001, mdl_v_expr_id, mdl_icode_id, mdl_stmt_id, mdl_list_stmt_id, mdl_for_stmt_id, mdl_if_stmt_id, mdl_seq_stmt_id, mdl_instr_stmt_id, mdl_constraint_id, mdl_metric_id} class_ids;
struct batch_buffer_entry{ 
int mid;
double startTimeStamp;
double endTimeStamp;
double value;
u_int weight;
bool internal_met;

   batch_buffer_entry &operator=(const batch_buffer_entry &src) {
      mid = src.mid;
      startTimeStamp = src.startTimeStamp;
      endTimeStamp = src.endTimeStamp;
      value = src.value;
      weight = src.weight;
      internal_met = src.internal_met;
      return *this;
   }
};
typedef struct batch_buffer_entry batch_buffer_entry;
static bool_t P_xdr_batch_buffer_entry(XDR * obj, batch_buffer_entry* data);
static bool_t P_xdr_batch_buffer_entry_PTR(XDR * obj, batch_buffer_entry** data);
struct trace_batch_buffer_entry{ 
int mid;
u_int length;
byteArray traceRecord;

   trace_batch_buffer_entry &operator=(const trace_batch_buffer_entry &src) {
      mid = src.mid;
      length = src.length;
      traceRecord = src.traceRecord;
      return *this;
   }
};
typedef struct trace_batch_buffer_entry trace_batch_buffer_entry;
static bool_t P_xdr_trace_batch_buffer_entry(XDR * obj, trace_batch_buffer_entry* data);
static bool_t P_xdr_trace_batch_buffer_entry_PTR(XDR * obj, trace_batch_buffer_entry** data);
class mdl_expr{ 
 public: 
 mdl_expr();

public:
  virtual ~mdl_expr();
  virtual bool apply(mdl_var &ret) = 0;
  virtual bool apply(AstNode*& ast) = 0;
  virtual bool mk_list(vector<string> &funcs) = 0;
#ifdef NO_MDL_PRINT
  virtual void print(ostream& os) = 0;
#endif
public:
virtual bool_t marshall (XDR * obj);
virtual class_ids getId() { return mdl_expr_id;}
};
static bool_t P_xdr_mdl_expr(XDR * obj, mdl_expr* data);
static bool_t P_xdr_mdl_expr_PTR(XDR * obj, mdl_expr** data);
class mdl_v_expr : public mdl_expr { 
 public: 
 mdl_v_expr();
u_int type_;
int int_literal_;
string str_literal_;
string var_;
u_int bin_op_;
u_int u_op_;
mdl_expr* left_;
mdl_expr* right_;
vector<mdl_expr*>* args_;
vector<string> fields_;
vector<u_int> type_walk;
bool do_type_walk_;
bool ok_;

public:
  mdl_v_expr(int int_literal);
  mdl_v_expr(string a_str, bool is_literal);
  mdl_v_expr(mdl_expr* expr, vector<string> fields);
  mdl_v_expr(string func_name, vector<mdl_expr*> *args);
  mdl_v_expr(u_int bin_op, mdl_expr *left, mdl_expr *right);
  mdl_v_expr(string var, u_int assign_op, mdl_expr* expr);
  mdl_v_expr(u_int u_op, mdl_expr *expr, bool is_preop);
  mdl_v_expr(string var, mdl_expr *index_expr);
  ~mdl_v_expr();
  bool apply(mdl_var &ret); // non-code-gen version
  bool apply(AstNode*& mn); // code-gen version
  bool mk_list(vector<string> &funcs);
#ifdef NO_MDL_PRINT
  virtual void print(ostream& os) 
  {
    os << "MDL_V_EXPR: var=" << var_ << " do_type_walk=" << do_type_walk_;
    unsigned size = fields_.size(), index;
    if (size) 
    {
      os << "Fields: ";
      for (index=0; index<size; index++) 
        os << fields_[index] << " ";
      os << endl;
    }
  }
#endif

public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_v_expr_id;}
};
static bool_t P_xdr_mdl_v_expr(XDR * obj, mdl_v_expr* data);
static bool_t P_xdr_mdl_v_expr_PTR(XDR * obj, mdl_v_expr** data);
class mdl_icode{ 
 public: 
 mdl_icode();
mdl_expr* if_expr_;
mdl_expr* expr_;

public:
  mdl_icode(mdl_expr *if_expr, mdl_expr *expr);
  ~mdl_icode();
  bool apply(AstNode *&mn, bool mn_initialized);
public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_icode_id;}
};
static bool_t P_xdr_mdl_icode(XDR * obj, mdl_icode* data);
static bool_t P_xdr_mdl_icode_PTR(XDR * obj, mdl_icode** data);
class mdl_stmt{ 
 public: 
 mdl_stmt();

public:
  virtual ~mdl_stmt() { }
  virtual bool apply(metricDefinitionNode *mn, vector<dataReqNode*>& flags) = 0;
  virtual bool mk_list(vector<string> &funcs) = 0;
#ifdef NO_MDL_PRINT
  virtual void print(ostream& os) = 0;
#endif
public:
virtual bool_t marshall (XDR * obj);
virtual class_ids getId() { return mdl_stmt_id;}
};
static bool_t P_xdr_mdl_stmt(XDR * obj, mdl_stmt* data);
static bool_t P_xdr_mdl_stmt_PTR(XDR * obj, mdl_stmt** data);
class mdl_list_stmt : public mdl_stmt { 
 public: 
 mdl_list_stmt();
u_int type_;
string id_;
vector<string>* elements_;
bool is_lib_;
vector<string>* flavor_;

public:
  mdl_list_stmt(u_int type, string ident, vector<string> *elems,
		bool is_lib, vector<string> *flavor);
  virtual ~mdl_list_stmt();
  virtual bool apply(metricDefinitionNode *mn, vector<dataReqNode*>& flags);
  virtual bool mk_list(vector<string> &funcs);
#ifdef NO_MDL_PRINT
  virtual void print(ostream&) { }
#endif

public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_list_stmt_id;}
};
static bool_t P_xdr_mdl_list_stmt(XDR * obj, mdl_list_stmt* data);
static bool_t P_xdr_mdl_list_stmt_PTR(XDR * obj, mdl_list_stmt** data);
class mdl_for_stmt : public mdl_stmt { 
 public: 
 mdl_for_stmt();
mdl_stmt* for_body_;
string index_name_;
mdl_expr* list_expr_;

public:
  mdl_for_stmt(string index_name, mdl_expr *list_exp, mdl_stmt *body);
  virtual ~mdl_for_stmt();
  virtual bool apply(metricDefinitionNode *mn, vector<dataReqNode*>& flags);
  virtual bool mk_list(vector<string> &funcs);
#ifdef NO_MDL_PRINT
  virtual void print(ostream&) { }
#endif

public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_for_stmt_id;}
};
static bool_t P_xdr_mdl_for_stmt(XDR * obj, mdl_for_stmt* data);
static bool_t P_xdr_mdl_for_stmt_PTR(XDR * obj, mdl_for_stmt** data);
class mdl_if_stmt : public mdl_stmt { 
 public: 
 mdl_if_stmt();
mdl_expr* expr_;
mdl_stmt* body_;

public:
  mdl_if_stmt(mdl_expr *expr, mdl_stmt *body);
  virtual ~mdl_if_stmt();
  virtual bool apply(metricDefinitionNode *mn, vector<dataReqNode*>& flags);
  virtual bool mk_list(vector<string> &funcs);
#ifdef NO_MDL_PRINT
  virtual void print(ostream&) { }
#endif

public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_if_stmt_id;}
};
static bool_t P_xdr_mdl_if_stmt(XDR * obj, mdl_if_stmt* data);
static bool_t P_xdr_mdl_if_stmt_PTR(XDR * obj, mdl_if_stmt** data);
class mdl_seq_stmt : public mdl_stmt { 
 public: 
 mdl_seq_stmt();
vector<mdl_stmt*>* stmts_;

public:
  mdl_seq_stmt(vector<mdl_stmt*> *stmts);
  virtual ~mdl_seq_stmt();
  virtual bool apply(metricDefinitionNode *mn, vector<dataReqNode*>& flags);
  virtual bool mk_list(vector<string> &funcs);
#ifdef NO_MDL_PRINT
  virtual void print(ostream&) { }
#endif

public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_seq_stmt_id;}
};
static bool_t P_xdr_mdl_seq_stmt(XDR * obj, mdl_seq_stmt* data);
static bool_t P_xdr_mdl_seq_stmt_PTR(XDR * obj, mdl_seq_stmt** data);
class mdl_instr_stmt : public mdl_stmt { 
 public: 
 mdl_instr_stmt();
u_int position_;
mdl_expr* point_expr_;
vector<mdl_icode*>* icode_reqs_;
u_int where_instr_;
bool constrained_;

public:
  mdl_instr_stmt(u_int pos, mdl_expr *point_expr, vector<mdl_icode*> *i_reqs,
		 unsigned where_instr, bool constrained);
  virtual ~mdl_instr_stmt();
  virtual bool apply(metricDefinitionNode *mn, vector<dataReqNode*>& flags);
  virtual bool mk_list(vector<string> &funcs);
#ifdef NO_MDL_PRINT
  virtual void print(ostream& os) {
    os << "MDL_INSTR_STMT: constrained=" << constrained_ << " ";
    point_expr_->print(os);
  }
#endif

public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_instr_stmt_id;}
};
static bool_t P_xdr_mdl_instr_stmt(XDR * obj, mdl_instr_stmt* data);
static bool_t P_xdr_mdl_instr_stmt_PTR(XDR * obj, mdl_instr_stmt** data);
class mdl_constraint{ 
 public: 
 mdl_constraint();
string id_;
vector<string>* match_path_;
vector<mdl_stmt*>* stmts_;
bool replace_;
u_int data_type_;
u_int hierarchy_;
u_int type_;

public:
  mdl_constraint(string id, vector<string> *match_path,
		 vector<mdl_stmt*> *stmts, bool replace, u_int d_type,
		 bool& error);
  ~mdl_constraint();
  bool apply(metricDefinitionNode *mn, dataReqNode *&flag,
	     vector<string>& resource, process *proc, pdThread* thr,  bool computingCost);
  bool mk_list(vector<string> &funcs);
  bool replace();
  string id();

#ifdef NO_MDL_PRINT
   friend ostream& operator<< (ostream& os, const mdl_constraint& cons) {
     os << "\nConstraint: " << cons.id_ << " ";
     unsigned size, index;
     if (cons.match_path_) {
       size = cons.match_path_->size();
       for (index=0; index<size; index++) os << (*cons.match_path_)[index] << "/";
       os << endl;
     }
     os << "Replace=" << cons.replace_ << " Data_type=" << cons.data_type_ << " Hierarchy=" 
       << cons.hierarchy_ << " Type=" << cons.type_ << endl;
    if (cons.stmts_) {
      size = cons.stmts_->size();
      os << "Statements\n";
      for (index=0; index<size; index++) {
	(*cons.stmts_)[index]->print(os);
	os << " ";
      }
    }
    return os;
   }
#endif

public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_constraint_id;}
};
static bool_t P_xdr_mdl_constraint(XDR * obj, mdl_constraint* data);
static bool_t P_xdr_mdl_constraint_PTR(XDR * obj, mdl_constraint** data);
class mdl_metric{ 
 public: 
 mdl_metric();
string id_;
string name_;
string units_;
u_int agg_op_;
u_int style_;
u_int type_;
vector<mdl_stmt*>* stmts_;
vector<string>* flavors_;
vector<mdl_constraint*>* constraints_;
vector<string>* temp_ctr_;
bool developerMode_;
int unitstype_;

public:
  mdl_metric(string id, string name, string units,
	     u_int agg, u_int style, u_int type,
	     vector<mdl_stmt*> *mv, vector<string> *flavs, 
	     vector<mdl_constraint*> *cons,
	     vector<string> *temp_c, bool developerMode,int unitstype);
  ~mdl_metric();
#ifdef NO_MDL_PRINT
  friend ostream& operator<< (ostream &os, const mdl_metric& met) {
    os << "\nMetric: " << met.id_ << " " << met.name_ << " agg_op=" << met.agg_op_ << " style=" 
      << met.style_ << " type=" << met.type_ << endl;
    unsigned size, index;
    if (met.stmts_) {
      size = met.stmts_->size();
      os << "Statements\n";
      for (index=0; index<size; index++) {
	(*met.stmts_)[index]->print(os);
	 os << " ";
      }
    }
    if (met.constraints_) {
      size = met.constraints_->size();
      os << "Constraints\n";
      for (index=0; index<size; index++) {
	os << *((*met.constraints_)[index]) << " ";
      }
    }
    return os;
  }
#endif
  metricDefinitionNode *apply(vector< vector<string> >&focus, 
			      string& flat_name,
	                      vector<process *> procs,
			      vector< vector<pdThread *> >& threadsVec,
	                      bool replace_components_if_present,
			      bool computingCost);
public:
bool_t marshall (XDR * obj);
class_ids getId() { return mdl_metric_id;}
};
static bool_t P_xdr_mdl_metric(XDR * obj, mdl_metric* data);
static bool_t P_xdr_mdl_metric_PTR(XDR * obj, mdl_metric** data);
struct metricInfo{ 
string name;
int style;
int aggregate;
string units;
bool developerMode;
int unitstype;
u_int handle;
};
typedef struct metricInfo metricInfo;
static bool_t P_xdr_metricInfo(XDR * obj, metricInfo* data);
static bool_t P_xdr_metricInfo_PTR(XDR * obj, metricInfo** data);
struct focusStruct{ 
vector<u_int> focus;
};
typedef struct focusStruct focusStruct;
static bool_t P_xdr_focusStruct(XDR * obj, focusStruct* data);
static bool_t P_xdr_focusStruct_PTR(XDR * obj, focusStruct** data);
struct resourceInfoCallbackStruct{ 
u_int temporaryId;
vector<string> resource_name;
string abstraction;
u_int type;
};
typedef struct resourceInfoCallbackStruct resourceInfoCallbackStruct;
static bool_t P_xdr_resourceInfoCallbackStruct(XDR * obj, resourceInfoCallbackStruct* data);
static bool_t P_xdr_resourceInfoCallbackStruct_PTR(XDR * obj, resourceInfoCallbackStruct** data);
struct T_addExecutable{ 
vector<string> argv;
string dir;
};
typedef struct T_addExecutable T_addExecutable;
static bool_t P_xdr_T_addExecutable(XDR * obj, T_addExecutable* data);
static bool_t P_xdr_T_addExecutable_PTR(XDR * obj, T_addExecutable** data);
struct T_attach{ 
string path;
int pid;
int afterAttach;
};
typedef struct T_attach T_attach;
static bool_t P_xdr_T_attach(XDR * obj, T_attach* data);
static bool_t P_xdr_T_attach_PTR(XDR * obj, T_attach** data);
struct T_detachProgram{ 
int program;
bool pause;
};
typedef struct T_detachProgram T_detachProgram;
static bool_t P_xdr_T_detachProgram(XDR * obj, T_detachProgram* data);
static bool_t P_xdr_T_detachProgram_PTR(XDR * obj, T_detachProgram** data);
struct T_newProgramCallbackFunc{ 
int pid;
vector<string> argv;
string machine;
bool calledFromExec;
bool wantToInitiallyRun;
};
typedef struct T_newProgramCallbackFunc T_newProgramCallbackFunc;
static bool_t P_xdr_T_newProgramCallbackFunc(XDR * obj, T_newProgramCallbackFunc* data);
static bool_t P_xdr_T_newProgramCallbackFunc_PTR(XDR * obj, T_newProgramCallbackFunc** data);
struct T_showErrorCallback{ 
int errCode;
string errString;
string hostName;
};
typedef struct T_showErrorCallback T_showErrorCallback;
static bool_t P_xdr_T_showErrorCallback(XDR * obj, T_showErrorCallback* data);
static bool_t P_xdr_T_showErrorCallback_PTR(XDR * obj, T_showErrorCallback** data);
struct T_batchSampleDataCallbackFunc{ 
int program;
vector<batch_buffer_entry> theBatchBuffer;
};
typedef struct T_batchSampleDataCallbackFunc T_batchSampleDataCallbackFunc;
static bool_t P_xdr_T_batchSampleDataCallbackFunc(XDR * obj, T_batchSampleDataCallbackFunc* data);
static bool_t P_xdr_T_batchSampleDataCallbackFunc_PTR(XDR * obj, T_batchSampleDataCallbackFunc** data);
struct T_batchTraceDataCallbackFunc{ 
int program;
vector<trace_batch_buffer_entry> theTraceBatchBuffer;
};
typedef struct T_batchTraceDataCallbackFunc T_batchTraceDataCallbackFunc;
static bool_t P_xdr_T_batchTraceDataCallbackFunc(XDR * obj, T_batchTraceDataCallbackFunc* data);
static bool_t P_xdr_T_batchTraceDataCallbackFunc_PTR(XDR * obj, T_batchTraceDataCallbackFunc** data);
struct T_cpDataCallbackFunc{ 
int program;
double timeStamp;
int context;
double total;
double share;
};
typedef struct T_cpDataCallbackFunc T_cpDataCallbackFunc;
static bool_t P_xdr_T_cpDataCallbackFunc(XDR * obj, T_cpDataCallbackFunc* data);
static bool_t P_xdr_T_cpDataCallbackFunc_PTR(XDR * obj, T_cpDataCallbackFunc** data);
struct T_firstSampleCallback{ 
int program;
double time;
};
typedef struct T_firstSampleCallback T_firstSampleCallback;
static bool_t P_xdr_T_firstSampleCallback(XDR * obj, T_firstSampleCallback* data);
static bool_t P_xdr_T_firstSampleCallback_PTR(XDR * obj, T_firstSampleCallback** data);
struct T_AddCallGraphNodeCallback{ 
string exe_name;
string resource;
};
typedef struct T_AddCallGraphNodeCallback T_AddCallGraphNodeCallback;
static bool_t P_xdr_T_AddCallGraphNodeCallback(XDR * obj, T_AddCallGraphNodeCallback* data);
static bool_t P_xdr_T_AddCallGraphNodeCallback_PTR(XDR * obj, T_AddCallGraphNodeCallback** data);
struct T_AddCallGraphStaticChildrenCallback{ 
string exe_name;
string resource;
vector<string> children;
};
typedef struct T_AddCallGraphStaticChildrenCallback T_AddCallGraphStaticChildrenCallback;
static bool_t P_xdr_T_AddCallGraphStaticChildrenCallback(XDR * obj, T_AddCallGraphStaticChildrenCallback* data);
static bool_t P_xdr_T_AddCallGraphStaticChildrenCallback_PTR(XDR * obj, T_AddCallGraphStaticChildrenCallback** data);
struct T_AddCallGraphDynamicChildCallback{ 
string exe_name;
string parent;
string child;
};
typedef struct T_AddCallGraphDynamicChildCallback T_AddCallGraphDynamicChildCallback;
static bool_t P_xdr_T_AddCallGraphDynamicChildCallback(XDR * obj, T_AddCallGraphDynamicChildCallback* data);
static bool_t P_xdr_T_AddCallGraphDynamicChildCallback_PTR(XDR * obj, T_AddCallGraphDynamicChildCallback** data);
struct T_resourceInfoResponse{ 
vector<u_int> temporaryIds;
vector<u_int> resourceIds;
};
typedef struct T_resourceInfoResponse T_resourceInfoResponse;
static bool_t P_xdr_T_resourceInfoResponse(XDR * obj, T_resourceInfoResponse* data);
static bool_t P_xdr_T_resourceInfoResponse_PTR(XDR * obj, T_resourceInfoResponse** data);
struct T_mappingInfoCallback{ 
int program;
string abstraction;
string type;
string key;
string value;
};
typedef struct T_mappingInfoCallback T_mappingInfoCallback;
static bool_t P_xdr_T_mappingInfoCallback(XDR * obj, T_mappingInfoCallback* data);
static bool_t P_xdr_T_mappingInfoCallback_PTR(XDR * obj, T_mappingInfoCallback** data);
struct T_setTracking{ 
u_int resource_id;
bool var_31;
};
typedef struct T_setTracking T_setTracking;
static bool_t P_xdr_T_setTracking(XDR * obj, T_setTracking* data);
static bool_t P_xdr_T_setTracking_PTR(XDR * obj, T_setTracking** data);
struct T_enableDataCollection{ 
vector<focusStruct> focus;
vector<string> metric;
vector<u_int> mi_ids;
u_int daemon_id;
u_int request_id;
};
typedef struct T_enableDataCollection T_enableDataCollection;
static bool_t P_xdr_T_enableDataCollection(XDR * obj, T_enableDataCollection* data);
static bool_t P_xdr_T_enableDataCollection_PTR(XDR * obj, T_enableDataCollection** data);
struct T_enableDataCollection2{ 
vector<u_int> focus;
string metric;
int id;
};
typedef struct T_enableDataCollection2 T_enableDataCollection2;
static bool_t P_xdr_T_enableDataCollection2(XDR * obj, T_enableDataCollection2* data);
static bool_t P_xdr_T_enableDataCollection2_PTR(XDR * obj, T_enableDataCollection2** data);
struct T_enableDataCallback{ 
u_int daemon_id;
vector<int> return_id;
vector<u_int> mi_ids;
u_int request_id;
};
typedef struct T_enableDataCallback T_enableDataCallback;
static bool_t P_xdr_T_enableDataCallback(XDR * obj, T_enableDataCallback* data);
static bool_t P_xdr_T_enableDataCallback_PTR(XDR * obj, T_enableDataCallback** data);
struct T_getPredictedDataCostCallback{ 
u_int id;
u_int req_id;
float val;
u_int clientID;
};
typedef struct T_getPredictedDataCostCallback T_getPredictedDataCostCallback;
static bool_t P_xdr_T_getPredictedDataCostCallback(XDR * obj, T_getPredictedDataCostCallback* data);
static bool_t P_xdr_T_getPredictedDataCostCallback_PTR(XDR * obj, T_getPredictedDataCostCallback** data);
struct T_getPredictedDataCost{ 
u_int id;
u_int req_id;
vector<u_int> focus;
string metric;
u_int clientID;
};
typedef struct T_getPredictedDataCost T_getPredictedDataCost;
static bool_t P_xdr_T_getPredictedDataCost(XDR * obj, T_getPredictedDataCost* data);
static bool_t P_xdr_T_getPredictedDataCost_PTR(XDR * obj, T_getPredictedDataCost** data);
struct T_addResource{ 
u_int parent;
u_int id;
string name;
u_int type;
};
typedef struct T_addResource T_addResource;
static bool_t P_xdr_T_addResource(XDR * obj, T_addResource* data);
static bool_t P_xdr_T_addResource_PTR(XDR * obj, T_addResource** data);
struct T_applicationIO{ 
int pid;
int len;
string line;
};
typedef struct T_applicationIO T_applicationIO;
static bool_t P_xdr_T_applicationIO(XDR * obj, T_applicationIO* data);
static bool_t P_xdr_T_applicationIO_PTR(XDR * obj, T_applicationIO** data);
struct T_reportSelf{ 
string machine;
string program;
int pid;
string flavor;
};
typedef struct T_reportSelf T_reportSelf;
static bool_t P_xdr_T_reportSelf(XDR * obj, T_reportSelf* data);
static bool_t P_xdr_T_reportSelf_PTR(XDR * obj, T_reportSelf** data);
struct T_processStatus{ 
int pid;
u_int procstat;
};
typedef struct T_processStatus T_processStatus;
static bool_t P_xdr_T_processStatus(XDR * obj, T_processStatus* data);
static bool_t P_xdr_T_processStatus_PTR(XDR * obj, T_processStatus** data);
enum message_tags {
verify = 4000,
addExecutable_REQ, addExecutable_RESP,
attach_REQ, attach_RESP,
startProgram_REQ, startProgram_RESP,
pauseProgram_REQ, pauseProgram_RESP,
pauseApplication_REQ, pauseApplication_RESP,
continueProgram_REQ, continueProgram_RESP,
continueApplication_REQ, continueApplication_RESP,
detachProgram_REQ, detachProgram_RESP,
MonitorDynamicCallSites_REQ, MonitorDynamicCallSites_RESP,
newProgramCallbackFunc_REQ, newProgramCallbackFunc_RESP,
showErrorCallback_REQ, showErrorCallback_RESP,
batchSampleDataCallbackFunc_REQ, batchSampleDataCallbackFunc_RESP,
batchTraceDataCallbackFunc_REQ, batchTraceDataCallbackFunc_RESP,
cpDataCallbackFunc_REQ, cpDataCallbackFunc_RESP,
firstSampleCallback_REQ, firstSampleCallback_RESP,
resourceInfoCallback_REQ, resourceInfoCallback_RESP,
severalResourceInfoCallback_REQ, severalResourceInfoCallback_RESP,
CallGraphAddProgramCallback_REQ, CallGraphAddProgramCallback_RESP,
AddCallGraphNodeCallback_REQ, AddCallGraphNodeCallback_RESP,
AddCallGraphStaticChildrenCallback_REQ, AddCallGraphStaticChildrenCallback_RESP,
CallGraphSetEntryFuncCallback_REQ, CallGraphSetEntryFuncCallback_RESP,
CallGraphFillDone_REQ, CallGraphFillDone_RESP,
CallGraphAddDynamicCallSiteCallback_REQ, CallGraphAddDynamicCallSiteCallback_RESP,
AddCallGraphDynamicChildCallback_REQ, AddCallGraphDynamicChildCallback_RESP,
resourceInfoResponse_REQ, resourceInfoResponse_RESP,
resourceBatchMode_REQ, resourceBatchMode_RESP,
mappingInfoCallback_REQ, mappingInfoCallback_RESP,
newMetricCallback_REQ, newMetricCallback_RESP,
setSampleRate_REQ, setSampleRate_RESP,
setTracking_REQ, setTracking_RESP,
enableDataCollection_REQ, enableDataCollection_RESP,
enableDataCollection2_REQ, enableDataCollection2_RESP,
enableDataCallback_REQ, enableDataCallback_RESP,
getPredictedDataCostCallback_REQ, getPredictedDataCostCallback_RESP,
disableDataCollection_REQ, disableDataCollection_RESP,
endOfDataCollection_REQ, endOfDataCollection_RESP,
getPredictedDataCost_REQ, getPredictedDataCost_RESP,
getAvailableMetrics_REQ, getAvailableMetrics_RESP,
addResource_REQ, addResource_RESP,
applicationIO_REQ, applicationIO_RESP,
reportStatus_REQ, reportStatus_RESP,
getStatus_REQ, getStatus_RESP,
coreProcess_REQ, coreProcess_RESP,
reportSelf_REQ, reportSelf_RESP,
processStatus_REQ, processStatus_RESP,
printStats_REQ, printStats_RESP,
send_metrics_REQ, send_metrics_RESP,
send_constraints_REQ, send_constraints_RESP,
send_stmts_REQ, send_stmts_RESP,
send_libs_REQ, send_libs_RESP,
send_no_libs_REQ, send_no_libs_RESP,
getTime_REQ, getTime_RESP,
error, last }; 
 typedef enum message_tags message_tags;
typedef struct buf_struct {
void *data_ptr;
message_tags data_type;
} buf_struct;
};
#if defined(external_templates)
#pragma interface
#endif
template <class Cont, class Elem, class Bund_Func> 
inline
bool_t T_dyninstRPC_P_xdr_stl(XDR* obj, Cont *data, Bund_Func Func, Elem *ptr) {
assert(obj);
assert(obj->x_op != XDR_FREE);
if (obj->x_op == XDR_DECODE) {
unsigned index=0;
unsigned count;
if (!P_xdr_u_int(obj, (u_int*) &count))
 return FALSE;
while (index < count) {
 Elem element;
if (Func(obj, &element)) {
(*data) += element;
index++;
} else { 
break;
}
}
if (index == count) return TRUE; else return FALSE;
} else {
unsigned index=0;
unsigned count=data->size();
if (!P_xdr_u_int(obj, (u_int*) &count))
 return FALSE;
while ((index <count) && Func(obj, &((*data)[index]))) index++;
if (index == count) return TRUE; else return FALSE;
}
}
template <class Cont, class Elem, class Bund_Func> 
inline
bool_t T_dyninstRPC_P_xdr_stl_PTR(XDR* obj, Cont **data, Bund_Func Func, Elem *ptr) {
assert(obj);
assert(obj->x_op != XDR_FREE);
bool is_null = (*data == NULL);
if (!P_xdr_Boolean(obj, &is_null)) return FALSE;
if (obj->x_op == XDR_DECODE) {
if (is_null) { *data = NULL; return TRUE; }
*data = new Cont;
if (!*data) return FALSE;
return T_dyninstRPC_P_xdr_stl(obj, *data, Func, ptr);
} else {
if (!*data) return TRUE;
return T_dyninstRPC_P_xdr_stl(obj, *data, Func, ptr);
}
}

#endif

