#include <stdio.h>
#include <stdlib.h>
#include "thread/h/thread.h"

#define NTHREADS 32
#define NITER_I  1000
#define NITER_J  10000
#define NPRINT   (NITER_I/100)

static unsigned nthreads = 0;

static void* foo(void* arg) {
    thread_t tid;
    unsigned i, j;
    volatile unsigned k;

    tid = thr_self();
    printf("hello world, i am thread %u[%u] with arg %p\n", tid,
	thr_parent(), arg);
    printf("going into loop now ...\n");

    for (i = 0; i < NITER_I; i++) {
        for (j = 0; j < NITER_J; j++) {
            k = i*j;
        }
        if ((i % NPRINT) == 0) {
            printf("thread %u completed loop %u\n", tid, i);
        }
    }

    printf("goodbye world, i am thread %u\n", tid);
    printf("finishing loop now ...\n");

    return 0;
}

int main(int argc, char** argv) {
    unsigned i;
	thread_t tid;

    argv++; argc--;
    if (argc == 0) {
        nthreads = NTHREADS;
    }
    else {
        nthreads = atoi(*argv);
        argv++; argc--;
    }

    printf("hello world, this is main [tid = %u]\n", thr_self());
    printf("starting %u threads now ...\n", nthreads);

    for (i = 0; i < nthreads; i++) {
        thr_create(0, 0, &foo, 0, 0, &tid);
		printf( "thread %u [tid = %u]\n", i, tid );
    }

    printf("waiting for threads to complete\n");

    for (i = 0; i < nthreads; i++) {
        thr_join(0, 0, 0);
    }

    printf("goodbye world, this is main\n");
    printf("finishing process now ...\n");

    return 0;
}
